#include "indicadorled.h"
#include "ui_indicadorled.h"
#include <QJsonDocument>

IndicadorLed::IndicadorLed(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::IndicadorLed)
{
    ui->setupUi(this);
    //vSetLabelColor(ui->lbW,Qt::darkGray,Qt::darkGray);
    vSetLabelColor(ui->lbW,Qt::lightGray,Qt::lightGray);
    vSetLabelColor(ui->lbR,Qt::darkRed,Qt::darkRed);
    vSetLabelColor(ui->lbY,Qt::darkYellow,Qt::darkYellow);
    vSetLabelColor(ui->lbG,Qt::darkGreen,Qt::darkGreen);

    qjoJson = new QJsonObject;
    (*qjoJson)["ledW"] = false;
    (*qjoJson)["ledR"] = 0;
    (*qjoJson)["ledY"] = 0;
    (*qjoJson)["ledG"] = 0;

    vActualitzaJson(*qjoJson);
    vSetEnableCheckBoxes(false);
}

void IndicadorLed::vSetEnableCheckBoxes(bool b){
    ui->cbW->setEnabled(b);
    ui->cbR->setEnabled(b);
    ui->cbY->setEnabled(b);
    ui->cbG->setEnabled(b);
}

IndicadorLed::~IndicadorLed()
{
    delete ui;
}

void IndicadorLed::vActualitzaJson(QJsonObject qjsObj){
    QString strFromObj = QJsonDocument(qjsObj).toJson(QJsonDocument::Compact).toStdString().c_str();
    ui->etJson->setText(strFromObj);
    emit vTrametJsonLeds(strFromObj);
}

void IndicadorLed::vSetLabelColor(QLabel* et,QColor col, QColor rerefons){
    QPixmap *pix = new QPixmap(22,22);
    QPainter *paint = new QPainter(pix);
    //paint->setBrush(Qt::darkGreen);
    paint->setBrush(rerefons);
    paint->drawRect(0, 0, 21, 21);
    //paint->setBrush(Qt::green);&QTimer::timeout
    paint->setBrush(col);
    paint->setPen(Qt::white);
    paint->drawEllipse(5, 5, 10, 10);
    et->setPixmap(*pix);
}

void IndicadorLed::on_cbW_clicked(bool checked)
{
    //vSetLabelColor(ui->lbW,(checked)?Qt::lightGray:Qt::darkGray,Qt::darkGray);
    vSetLabelColor(ui->lbW,(checked)?Qt::white:Qt::lightGray,Qt::lightGray);
    (*qjoJson)["ledW"] = checked;
    vActualitzaJson(*qjoJson);
}

void IndicadorLed::on_cbR_clicked(bool checked){
    vSetLabelColor(ui->lbR,(checked)?Qt::red:Qt::darkRed,Qt::darkRed);
    (*qjoJson)["ledR"] = (checked)?1:0;
    vActualitzaJson(*qjoJson);
}

void IndicadorLed::on_cbY_clicked(bool checked){
    vSetLabelColor(ui->lbY,(checked)?Qt::yellow:Qt::darkYellow,Qt::darkYellow);
    (*qjoJson)["ledY"] = (checked)?1:0;
    vActualitzaJson(*qjoJson);
}

void IndicadorLed::on_cbG_clicked(bool checked){
    vSetLabelColor(ui->lbG,(checked)?Qt::green:Qt::darkGreen,Qt::darkGreen);
    (*qjoJson)["ledG"] = (checked)?1:0;
    vActualitzaJson(*qjoJson);
}

void IndicadorLed::vSetLed(QString qsLed,bool b){
    if(qsLed == "W"){
        ui->cbW->setChecked(b);
        on_cbW_clicked(b);
    }
    if(qsLed == "R"){
        ui->cbR->setChecked(b);
        on_cbR_clicked(b);
    }
    if(qsLed == "Y"){
        ui->cbY->setChecked(b);
        on_cbY_clicked(b);
    }
    if(qsLed == "G"){
        ui->cbG->setChecked(b);
        on_cbG_clicked(b);
    }
}
